#include <stdio.h>
#include <stdlib.h>
#include <dirent.h>
#include <string.h>

char key[32];
char pass[32];
unsigned char cnt = 0;
int i = 0;

char *check_dir = "./upload/";
char *flag_file = "/home/arthur/sign_key.flag";
char *pass_file = "/home/arthur/pass";

char found[255][192];
int cookie;

void clean_uploads();
void inspect(char *);
void log_result(unsigned char);

void sign(char*, char*);
void random_name(char *, unsigned int);

void __attribute__((constructor)) init() 
{
	FILE *random;
	FILE *file;
	FILE *password;

	random = fopen("/dev/urandom", "rb");
	file = fopen(flag_file, "rb");
	password = fopen(pass_file, "rb");

	if (!random || !file || !password)
		exit(1);

	fread(key, 30, 1, file);
	fread(&cookie, 4, 1, random);
	fread(&pass, 30, 1, password);

	fclose(file);
	fclose(random);
	fclose(password);
}

int main(int argc, char *argv[]) 
{
    if (argc < 2) {
		fprintf(stderr, "Usage: %s [--clean] [--sign <source code file> <password>]\n", argv[0]);
		exit(2);
	}

	if (!strcmp("--clean", argv[1]))
		clean_uploads();

	if (!strcmp("--sign", argv[1])) {
		if (argc != 4) {
			fprintf(stderr, "You must provide a file to sign and the password to do so\n");
			exit(2);		
		}

		sign(argv[2], argv[3]);
	}

	return 0;
}

void sign(char *source, char* password)
{
	int overflow = cookie;
	FILE *src_file;
	unsigned int size = 0;
    char *buffer = NULL;
    char *file = NULL;
    char path[30];

    if (strcmp(password, pass)) {
    	fprintf(stderr, "Wrong password...\n");
    	exit(5);
    }

    bzero(path, 30);

	src_file = fopen(source, "rb");
	if (src_file == NULL) {
		fprintf(stderr, "Source file doesn't exist\n");
		exit(3);
	}

    fseek(src_file, 0, SEEK_END);
    size = ftell(src_file);
    fseek(src_file, 0, SEEK_SET);

    buffer = (char*)malloc(size*sizeof(char));
    file = (char*)malloc(20*sizeof(char));

    if (buffer == NULL || file == NULL) {
    	fprintf(stderr, "Failed to allocate memory\n");
    	exit(4);
    }

    fread(buffer, size, 1, src_file);
    fclose(src_file);

    random_name(file, 19);

    snprintf(path, 31, "/tmp/%s", file);

    FILE *tmp_file;
    tmp_file = fopen(path, "wb");

    if (tmp_file == NULL) {
    	fprintf(stderr, "Failed to open tmp file for signing\n");
    	exit(5);
    }

    fwrite(key, sizeof(char), sizeof(key), tmp_file);
    fwrite(buffer, sizeof(char), size, tmp_file);
    fclose(tmp_file);

    char cmd[128];
    bzero(cmd, 128);

    snprintf(cmd, 127, "cat %s | sha512sum | awk '{print $1}' > signature", path);
    system(cmd);

    remove(path);

    if (overflow != cookie) {
		printf("overflow shit, cookie does not match: %s...\n", overflow);
		abort();
	}
}

void random_name(char *s, unsigned int len)
{
	unsigned int init;

    FILE *urandom = NULL;
    urandom = fopen("/dev/urandom", "rb");

    if (urandom == NULL) {
    	fprintf(stderr, "Failed to open /dev/urandom");
    	exit(0);
    }

    fread(&init, 4, 1, urandom);

    srand(init);
    const char *alpha = "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVXYZ";
    int i = 0;

    for (i; i<len; i++)
        s[i] = alpha[rand() % 60];

    s[len] = 0;
}

void clean_uploads()
{
	unsigned int i;
	struct dirent *dir;
	DIR *d;
	char path[256];
	bzero(path, 256);

	d = opendir(check_dir);
	if (d) {
		while ((dir = readdir(d)) != NULL) {
			if (!strcmp(".", dir->d_name) || !strcmp("..", dir->d_name))
				continue;

			inspect(dir->d_name);

			snprintf(path, 255, "%s%s", check_dir, dir->d_name);
			remove(path);
		}

		log_result(cnt);
		closedir(d);
	}
}

void inspect(char *filename) 
{
	FILE *fp;
	char path[255];
	char tmp[511];
	char *pos;

	snprintf(path, 255, "%s%s", check_dir, filename);

	if ((fp = fopen(path, "r")) == NULL)
		return;

	while (fgets(tmp, 511, fp) != NULL) {
		if ((pos = strstr(tmp, "system(\"")) != NULL) {
			unsigned int length;
			char *end = strstr(pos, "\");");

			if (end == NULL)
				continue;

			length = end-(pos+8);
			if (length > 192)
				length = 192;

			strncpy(found[cnt], pos+8, length);
			cnt++;
		}
	}
}

void log_result(unsigned char cnt) 
{
	int overflow = cookie;
	char buffer[224];

	bzero(buffer, 224);

	for (i=0; i<cnt; i++) {
		snprintf(buffer, strlen(found[i])+32, "systemcall (%d/%d): %s", i+1, cnt, found[i]);
		puts(buffer);
	}

	if (overflow != cookie) {
		printf("overflow shit, cookie does not match: %s...\n", overflow);
		abort();
	}
}
